(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     96564,       3234]
NotebookOptionsPosition[     80908,       2693]
NotebookOutlinePosition[     82271,       2736]
CellTagsIndexPosition[     82192,       2731]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[TextData[{
 "Functional Programming in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"]
}], "Title",
 CellChangeTimes->{{3.623833449674645*^9, 3.623833452303664*^9}, {
   3.62384314996313*^9, 3.623843161839814*^9}, 3.6238539007634697`*^9}],

Cell["A4M36TPJ, WS 14/15, Week 7 - Lecture", "Subtitle",
 CellChangeTimes->{{3.623833462047662*^9, 3.623833463383144*^9}, {
  3.6238431657681*^9, 3.623843184175523*^9}, {3.623953915214179*^9, 
  3.623953918046929*^9}}],

Cell["Zden\[EHacek]k Buk, bukz1@fel.cvut.cz", "Subsubtitle",
 CellChangeTimes->{{3.623843203729103*^9, 3.623843221757826*^9}}],

Cell["\<\
Dept. of Computer Science and Engineering
Faculty of Electrical Engineering
Czech Technical University in Prague\
\>", "Subsubtitle",
 CellChangeTimes->{{3.562581140905176*^9, 3.5625811745094767`*^9}, {
   3.584778972611209*^9, 3.584779002416012*^9}, {3.584779115297949*^9, 
   3.584779126024968*^9}, {3.5847791743688717`*^9, 3.58477919178168*^9}, 
   3.584779568147327*^9, {3.587355242449349*^9, 3.587355243760145*^9}, 
   3.587355336269288*^9, {3.587357048308634*^9, 3.587357053921727*^9}}],

Cell["Last update: Nov 2014", "Subsubtitle",
 CellChangeTimes->{{3.562581140905176*^9, 3.5625811745094767`*^9}, {
   3.584778972611209*^9, 3.584779002416012*^9}, {3.584779115297949*^9, 
   3.584779126024968*^9}, {3.5847791743688717`*^9, 3.58477919178168*^9}, 
   3.584779568147327*^9, {3.587355242449349*^9, 3.587355243760145*^9}, 
   3.587355336269288*^9, {3.587357048308634*^9, 3.5873570695359507`*^9}, {
   3.58987028580278*^9, 3.589870286272058*^9}, {3.5930984935972652`*^9, 
   3.593098494941304*^9}, {3.623843355833338*^9, 3.623843355905304*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Introduction", "Section",
 CellChangeTimes->{{3.6238433861765738`*^9, 3.623843411247705*^9}, {
  3.623843485997211*^9, 3.623843516612858*^9}}],

Cell[CellGroupData[{

Cell["Functional Programming", "Subsection",
 CellChangeTimes->{{3.6239560849613132`*^9, 3.623956088271514*^9}}],

Cell[TextData[{
 StyleBox["From Wikipedia, the free encyclopedia:",
  FontSlant->"Italic"],
 " Functional programming is a programming paradigm, a style of building the \
structure and elements of computer programs, that treats computation as the \
evaluation of mathematical functions and ",
 StyleBox["avoids changing-state",
  FontWeight->"Bold"],
 " and mutable data. It is a ",
 StyleBox["declarative programming paradigm",
  FontWeight->"Bold"],
 ", which means programming is done with expressions. In functional code, the \
",
 StyleBox["output value of a function depends only on the arguments",
  FontWeight->"Bold"],
 " that are input to the function, so calling a function f twice with the \
same value for an argument ",
 StyleBox["x",
  FontSlant->"Italic"],
 " will produce the same result ",
 StyleBox["f(x)",
  FontSlant->"Italic"],
 " each time. ",
 StyleBox["Eliminating side effects",
  FontWeight->"Bold"],
 ", i.e. changes in state that do not depend on the function inputs, can make \
it much easier to understand and ",
 StyleBox["predict the behavior of a program",
  FontWeight->"Bold"],
 ", which is one of the key motivations for the development of functional \
programming."
}], "Text",
 CellChangeTimes->{{3.62395621978399*^9, 3.6239562377485228`*^9}}],

Cell[CellGroupData[{

Cell["\<\
treats computation as the evaluation of mathematical functions\
\>", "Item",
 CellChangeTimes->{{3.6239563912091293`*^9, 3.623956392723269*^9}}],

Cell["avoids changing-state", "Item",
 CellChangeTimes->{{3.6239563912091293`*^9, 3.623956408051037*^9}}],

Cell["output value of a function depends only on the arguments", "Item",
 CellChangeTimes->{{3.6239563912091293`*^9, 3.6239564216703863`*^9}}],

Cell["\<\
eliminating side effects can make it much easier to predict the behavior of a \
program\
\>", "Item",
 CellChangeTimes->{{3.6239563912091293`*^9, 3.623956443829145*^9}, {
  3.623956623314476*^9, 3.623956631600051*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functional Programming Concepts", "Subsection",
 CellChangeTimes->{{3.6239566905039463`*^9, 3.6239566993822412`*^9}}],

Cell[CellGroupData[{

Cell["Higher-Order Functions", "Subsubsection",
 CellChangeTimes->{{3.623956968433064*^9, 3.623956984293817*^9}}],

Cell["\<\
functions that can either take other functions as arguments or return them as \
results\
\>", "Item",
 CellChangeTimes->{3.623957155846642*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"g_", ",", "x_"}], "]"}], ":=", 
  RowBox[{"g", "[", "x", "]"}]}]], "Input",
 CellChangeTimes->{{3.6239574803842897`*^9, 3.623957488669108*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"Sqrt", ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.623957497254203*^9, 3.623957505985736*^9}}],

Cell[BoxData[
 SqrtBox["x"]], "Output",
 CellChangeTimes->{3.6239936578500967`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"g_", ",", "x_"}], "]"}], ":=", 
  RowBox[{"Function", "[", 
   RowBox[{
    RowBox[{"{", "y", "}"}], ",", 
    RowBox[{"g", "[", 
     RowBox[{"x", "+", "y"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.623957522164612*^9, 3.6239575451757183`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"Sqrt", ",", "42"}], "]"}]], "Input",
 CellChangeTimes->{{3.623957547405238*^9, 3.6239575550555687`*^9}}],

Cell[BoxData[
 RowBox[{"Function", "[", 
  RowBox[{
   RowBox[{"{", "y$", "}"}], ",", 
   SqrtBox[
    RowBox[{"42", "+", "y$"}]]}], "]"}]], "Output",
 CellChangeTimes->{3.623993657966435*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"Sqrt", ",", "42"}], "]"}], "[", "z", "]"}]], "Input",
 CellChangeTimes->{{3.623957547405238*^9, 3.623957575000373*^9}}],

Cell[BoxData[
 SqrtBox[
  RowBox[{"42", "+", "z"}]]], "Output",
 CellChangeTimes->{3.6239936580338*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pure Functions", "Subsubsection",
 CellChangeTimes->{{3.623956988060231*^9, 3.623956992125671*^9}}],

Cell["Purely functional functions have no side effects.", "Text",
 CellChangeTimes->{{3.623957332785027*^9, 3.623957337119841*^9}}],

Cell[CellGroupData[{

Cell["\<\
If the result of a pure expression is not used, it can be removed without \
affecting other expressions.\
\>", "Item",
 CellChangeTimes->{{3.6239573596279707`*^9, 3.623957360778749*^9}}],

Cell["\<\
If there is no data dependency between two pure expressions, then their order \
can be reversed, or they can be performed in parallel.\
\>", "Item",
 CellChangeTimes->{{3.6239573596279707`*^9, 3.623957360757866*^9}, {
  3.6239573958375473`*^9, 3.62395739833808*^9}}],

Cell["\<\
If a pure function is called with arguments that cause no side-effects, the \
result is constant with respect to that argument list.\
\>", "Item",
 CellChangeTimes->{{3.6239573596279707`*^9, 3.623957360757866*^9}, {
  3.6239573958375473`*^9, 3.623957398322235*^9}, {3.623957432604986*^9, 
  3.623957433532558*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 StyleBox[
  ButtonBox[
   StyleBox[
    ButtonBox[
     StyleBox[
      RowBox[{"tutorial", "/", "PureFunctions"}], "Text"],
     BaseStyle->"Hyperlink",
     ButtonData->{
       FrontEnd`FileName[{"tutorial"}, "PureFunctions", CharacterEncoding -> 
        "UTF-8"], None}], "Text"],
   BaseStyle->"Link",
   ButtonData->"paclet:tutorial/PureFunctions"], "Text"]], "Input",
 CellChangeTimes->{{3.623957673950728*^9, 3.6239577031414223`*^9}}],

Cell[BoxData[
 ButtonBox[
  ButtonBox[
   FractionBox["tutorial", "PureFunctions"],
   Appearance->Automatic,
   ButtonData->{
     FrontEnd`FileName[{"tutorial"}, "PureFunctions", CharacterEncoding -> 
      "UTF-8"], None},
   Evaluator->Automatic,
   Method->"Preemptive"],
  Appearance->Automatic,
  BaseStyle->"Link",
  ButtonData->"paclet:tutorial/PureFunctions",
  Evaluator->Automatic,
  Method->"Preemptive"]], "Output",
 CellChangeTimes->{3.6239936581057367`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Function", "[", 
  RowBox[{
   RowBox[{"{", "x", "}"}], ",", 
   RowBox[{
    RowBox[{"x", "^", "2"}], "+", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.623957737819332*^9, 3.62395774400404*^9}}],

Cell[BoxData[
 RowBox[{"Function", "[", 
  RowBox[{
   RowBox[{"{", "x", "}"}], ",", 
   RowBox[{
    SuperscriptBox["x", "2"], "+", "1"}]}], "]"}]], "Output",
 CellChangeTimes->{3.6239936581823053`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Function", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{
     RowBox[{"x", "^", "2"}], "+", "1"}]}], "]"}], "[", "z", "]"}]], "Input",
 CellChangeTimes->{{3.623957737819332*^9, 3.6239577545713453`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  SuperscriptBox["z", "2"]}]], "Output",
 CellChangeTimes->{3.623993658249276*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], "[", "z", "]"}]], "Input",
 CellChangeTimes->{{3.6239577596662683`*^9, 3.6239577664576387`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  SuperscriptBox["z", "2"]}]], "Output",
 CellChangeTimes->{3.623993658291346*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.62395780941961*^9, 3.623957849152954*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "5", ",", "10", ",", "17", ",", "26", ",", "37"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.623993658341776*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParallelMap", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"#", "^", "2"}], "+", "1"}], "&"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], "}"}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.62395780941961*^9, 3.623957853970056*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", "5", ",", "10", ",", "17", ",", "26", ",", "37"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.623993659619775*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Recursion", "Subsubsection",
 CellChangeTimes->{{3.623956998039544*^9, 3.623956999565442*^9}}],

Cell["\<\
Iteration (looping) in functional languages is usually accomplished via \
recursion.\
\>", "Text",
 CellChangeTimes->{3.623957955846232*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "f", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{"1", "/;", 
   RowBox[{"x", "<", "1"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "*", 
   RowBox[{"f", "[", 
    RowBox[{"x", "-", "1"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{
  3.623957943311984*^9, 3.6239580000453033`*^9, {3.6239580365821323`*^9, 
   3.623958098235532*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "1", "]"}]], "Input",
 CellChangeTimes->{{3.623958099476604*^9, 3.6239581002985783`*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.623993660105431*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "4", "]"}]], "Input",
 CellChangeTimes->{{3.623958116876087*^9, 3.6239581176594152`*^9}}],

Cell[BoxData["24"], "Output",
 CellChangeTimes->{3.623993660293605*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "10", "]"}]], "Input",
 CellChangeTimes->{{3.623958101511524*^9, 3.623958102569447*^9}}],

Cell[BoxData["3628800"], "Output",
 CellChangeTimes->{3.623993660438468*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "g", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Nest", "[", 
  RowBox[{"g", ",", "x", ",", "3"}], "]"}]}], "Input",
 CellChangeTimes->{{3.6239581472078667`*^9, 3.623958162824339*^9}}],

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"g", "[", 
   RowBox[{"g", "[", "x", "]"}], "]"}], "]"}]], "Output",
 CellChangeTimes->{3.6239936605418797`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"f", ",", "x", ",", "a", ",", "b", ",", "c", ",", "d", ",", "e"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.623958737385729*^9, 3.62395874682306*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fold", "[", 
  RowBox[{"f", ",", "x", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{
   RowBox[{"f", "[", 
    RowBox[{
     RowBox[{"f", "[", 
      RowBox[{
       RowBox[{"f", "[", 
        RowBox[{"x", ",", "a"}], "]"}], ",", "b"}], "]"}], ",", "c"}], "]"}], 
   ",", "d"}], "]"}]], "Output",
 CellChangeTimes->{3.623993660667789*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell[TextData[{
 "Functions in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"]
}], "Section",
 CellChangeTimes->{{3.6238433861765738`*^9, 3.623843411247705*^9}, {
  3.623843485997211*^9, 3.623843516612858*^9}, {3.623958817710945*^9, 
  3.623958824940056*^9}}],

Cell[CellGroupData[{

Cell["Defining Functions", "Subsection",
 CellChangeTimes->{{3.6238677556630898`*^9, 3.623867758468679*^9}, {
  3.6239588309475613`*^9, 3.623958853347007*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", 
   RowBox[{"f", ",", "g"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"g", "[", "x", "]"}], "+", "1"}]}]}], "Input",
 CellChangeTimes->{{3.623867590363885*^9, 3.623867598075354*^9}, {
  3.623867644628359*^9, 3.623867655369237*^9}, {3.62386783719783*^9, 
  3.623867838802619*^9}, {3.623958875239778*^9, 3.623958875347451*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "10", "]"}]], "Input",
 CellChangeTimes->{{3.6238676070006332`*^9, 3.62386760900351*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", "10", "]"}]}]], "Output",
 CellChangeTimes->{3.6239936614196167`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Clear", "[", "f", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"f", "=", 
  RowBox[{"Function", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{
     RowBox[{"g", "[", "x", "]"}], "+", "1"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6238676117682743`*^9, 3.623867650665379*^9}, {
  3.6238678449951344`*^9, 3.62386784662752*^9}}],

Cell[BoxData[
 RowBox[{"Function", "[", 
  RowBox[{
   RowBox[{"{", "x", "}"}], ",", 
   RowBox[{
    RowBox[{"g", "[", "x", "]"}], "+", "1"}]}], "]"}]], "Output",
 CellChangeTimes->{3.623993661519216*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "10", "]"}]], "Input",
 CellChangeTimes->{{3.6238676585457373`*^9, 3.6238676607289553`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", "10", "]"}]}]], "Output",
 CellChangeTimes->{3.6239936616322737`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Function", "[", 
   RowBox[{
    RowBox[{"{", "x", "}"}], ",", 
    RowBox[{
     RowBox[{"g", "[", "x", "]"}], "+", "1"}]}], "]"}], "[", "10", 
  "]"}]], "Input",
 CellChangeTimes->{{3.6238676639450893`*^9, 3.62386767090514*^9}, {
  3.623867851643725*^9, 3.623867853917679*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", "10", "]"}]}]], "Output",
 CellChangeTimes->{3.6239936618175173`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"g", "[", "#", "]"}], "+", "1"}], "&"}], "[", "10", 
  "]"}]], "Input",
 CellChangeTimes->{{3.623867673802431*^9, 3.6238676808407183`*^9}, {
  3.6238678573072557`*^9, 3.6238678589149637`*^9}, {3.623958887812834*^9, 
  3.623958888974112*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", "10", "]"}]}]], "Output",
 CellChangeTimes->{3.6239936619668913`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"g", "[", "#x", "]"}], "+", "1"}], "&"}], "[", 
  RowBox[{"\[LeftAssociation]", 
   RowBox[{"\"\<x\>\"", "\[Rule]", "10"}], "\[RightAssociation]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.623867683210165*^9, 3.623867710176242*^9}, {
  3.62386786204257*^9, 3.62386786394697*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", "10", "]"}]}]], "Output",
 CellChangeTimes->{3.6239936620413933`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multiple Arguments", "Subsubsection",
 CellChangeTimes->{{3.623958906152747*^9, 3.623958911424836*^9}, {
  3.6239589925589943`*^9, 3.623958992854788*^9}}],

Cell[BoxData[{
 RowBox[{"Clear", "[", "f", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", 
   RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"x", "^", "2"}], "+", "y", "+", "1"}]}]}], "Input",
 CellChangeTimes->{{3.623958921150964*^9, 3.6239589360658617`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"a", ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.623958937721858*^9, 3.6239589392182913`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  SuperscriptBox["a", "2"], "+", "b"}]], "Output",
 CellChangeTimes->{3.6239936621085453`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Function", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], ",", 
    RowBox[{
     RowBox[{"x", "^", "2"}], "+", "y", "+", "1"}]}], "]"}], "[", 
  RowBox[{"a", ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.623958944357026*^9, 3.623958958713307*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  SuperscriptBox["a", "2"], "+", "b"}]], "Output",
 CellChangeTimes->{3.6239936621477137`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"#1", "^", "2"}], "+", "#2", "+", "1"}], "&"}], "[", 
  RowBox[{"a", ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.623958961167206*^9, 3.6239589678902283`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  SuperscriptBox["a", "2"], "+", "b"}]], "Output",
 CellChangeTimes->{3.623993662227173*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calling Function", "Subsection",
 CellChangeTimes->{{3.623868024877729*^9, 3.623868025955394*^9}, {
  3.62395897559156*^9, 3.623958976855338*^9}}],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "f", "]"}]], "Input",
 CellChangeTimes->{{3.623868031641986*^9, 3.623868034151374*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "x", "]"}]], "Input",
 CellChangeTimes->{{3.6238680358689003`*^9, 3.623868037063079*^9}}],

Cell[BoxData[
 RowBox[{"f", "[", "x", "]"}]], "Output",
 CellChangeTimes->{3.623993662303219*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "@", "x"}]], "Input",
 CellChangeTimes->{{3.623868046157262*^9, 3.623868047124563*^9}}],

Cell[BoxData[
 RowBox[{"f", "[", "x", "]"}]], "Output",
 CellChangeTimes->{3.623993662350746*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", "//", "f"}]], "Input",
 CellChangeTimes->{{3.6238680404668818`*^9, 3.623868041980616*^9}}],

Cell[BoxData[
 RowBox[{"f", "[", "x", "]"}]], "Output",
 CellChangeTimes->{3.623993662399748*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"g", "[", "x", "]"}], "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.62386816344726*^9, 3.623868186823859*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", "//", "f"}]], "Input",
 CellChangeTimes->{{3.623868196909812*^9, 3.623868198391336*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", "x", "]"}]}]], "Output",
 CellChangeTimes->{3.623993662510161*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"x", "//", 
  RowBox[{
   RowBox[{
    RowBox[{"g", "[", "#", "]"}], "+", "1"}], "&"}]}]], "Input",
 CellChangeTimes->{{3.623868202136675*^9, 3.623868208583067*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", "x", "]"}]}]], "Output",
 CellChangeTimes->{3.623993662626338*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"data", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "10"}], "}"}], ",", "10"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6238682246271887`*^9, 3.623868238565956*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "7", ",", "5", ",", "8", ",", "5", ",", "8", ",", "5", 
   ",", "4", ",", "9"}], "}"}]], "Output",
 CellChangeTimes->{3.623993662761037*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Min", "[", "data", "]"}], ",", 
   RowBox[{"Max", "[", "data", "]"}], ",", 
   RowBox[{"Mean", "[", "data", "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.623868242286476*^9, 3.623868259360693*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "9", ",", 
   FractionBox["26", "5"]}], "}"}]], "Output",
 CellChangeTimes->{3.623993662862434*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"ClearAll", "[", "f", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Min", "[", "x", "]"}], ",", 
    RowBox[{"Max", "[", "x", "]"}], ",", 
    RowBox[{"Mean", "[", "x", "]"}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.623868286745996*^9, 3.6238683054276876`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "data", "]"}]], "Input",
 CellChangeTimes->{{3.6238683068253927`*^9, 3.62386830790303*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "9", ",", 
   FractionBox["26", "5"]}], "}"}]], "Output",
 CellChangeTimes->{3.623993663000307*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Min", "[", "#", "]"}], ",", 
     RowBox[{"Max", "[", "#", "]"}], ",", 
     RowBox[{"Mean", "[", "#", "]"}]}], "}"}], "&"}], "@", "data"}]], "Input",\

 CellChangeTimes->{{3.6238683151406193`*^9, 3.623868330923685*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "9", ",", 
   FractionBox["26", "5"]}], "}"}]], "Output",
 CellChangeTimes->{3.623993663057411*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"data", "//", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Min", "[", "#", "]"}], ",", 
     RowBox[{"Max", "[", "#", "]"}], ",", 
     RowBox[{"Mean", "[", "#", "]"}]}], "}"}], "&"}]}]], "Input",
 CellChangeTimes->{{3.6238683151406193`*^9, 3.623868347284505*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "9", ",", 
   FractionBox["26", "5"]}], "}"}]], "Output",
 CellChangeTimes->{3.6239936631249332`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "+", "b"}]], "Input",
 CellChangeTimes->{{3.6239590614619703`*^9, 3.62395907160548*^9}}],

Cell[BoxData[
 RowBox[{"a", "+", "b"}]], "Output",
 CellChangeTimes->{3.6239936631752663`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plus", "[", 
  RowBox[{"a", ",", "b"}], "]"}]], "Input",
 CellChangeTimes->{{3.6239590654929953`*^9, 3.623959074757904*^9}}],

Cell[BoxData[
 RowBox[{"a", "+", "b"}]], "Output",
 CellChangeTimes->{3.623993663240872*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "~", "Plus", "~", "b"}]], "Input",
 CellChangeTimes->{{3.623959053460546*^9, 3.623959077478836*^9}}],

Cell[BoxData[
 RowBox[{"a", "+", "b"}]], "Output",
 CellChangeTimes->{3.623993663292371*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "~", "Join", "~", 
  RowBox[{"{", 
   RowBox[{"4", ",", "5", ",", "6"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.623959079221221*^9, 3.623959086727023*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.6239936633413153`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "~", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"#1", "^", "2"}], "+", 
     RowBox[{"#2", "^", "3"}]}], "&"}], ")"}], "~", "b"}]], "Input",
 CellChangeTimes->{{3.623959094194457*^9, 3.623959117332552*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["a", "2"], "+", 
  SuperscriptBox["b", "3"]}]], "Output",
 CellChangeTimes->{3.623993663397172*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mapping", "Subsection",
 CellChangeTimes->{{3.623867764500132*^9, 3.623867784596878*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "f", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{
   RowBox[{"g", "[", "x", "]"}], "+", "1"}]}]}], "Input",
 CellChangeTimes->{{3.623867786608438*^9, 3.6238677933168707`*^9}, {
  3.6238678269270077`*^9, 3.6238678286914454`*^9}, {3.623867981223001*^9, 
  3.623867981671612*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Range", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.623867880008713*^9, 3.623867882146709*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}]], "Output",
 CellChangeTimes->{3.623993663465534*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"Range", "[", "5", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.623867796136142*^9, 3.623867804811841*^9}, {
  3.6238678859113083`*^9, 3.6238678874280787`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"g", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3", ",", "4", ",", "5"}], "}"}], 
   "]"}]}]], "Output",
 CellChangeTimes->{3.6239936635242147`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Map", "[", 
  RowBox[{"f", ",", 
   RowBox[{"Range", "[", "5", "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.623867870769094*^9, 3.623867894521722*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "1", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "2", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "3", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "4", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "5", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.6239936635754423`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "/@", 
  RowBox[{"Range", "[", "5", "]"}]}]], "Input",
 CellChangeTimes->{{3.623867915263247*^9, 3.623867918491353*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "1", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "2", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "3", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "4", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "5", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.6239936636473637`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Attributes", "[", "f", "]"}]], "Input",
 CellChangeTimes->{{3.6238679495933867`*^9, 3.623867952306028*^9}}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{3.623993663706604*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"SetAttributes", "[", 
  RowBox[{"f", ",", "Listable"}], "]"}]], "Input",
 CellChangeTimes->{{3.623867954629181*^9, 3.623867967899448*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"Range", "[", "5", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.62386796940768*^9, 3.623867974145076*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "1", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "2", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "3", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "4", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "5", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.623993663790854*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"g", "[", "x", "]"}], "+", "1"}], "&"}], "/@", 
  RowBox[{"Range", "[", "5", "]"}]}]], "Input",
 CellChangeTimes->{{3.623867923610899*^9, 3.623867931690969*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "x", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "x", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "x", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "x", "]"}]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"g", "[", "x", "]"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.623993663847579*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell[TextData[{
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ": Core Language"
}], "Section",
 CellChangeTimes->{{3.6238433861765738`*^9, 3.623843411247705*^9}, {
  3.623843485997211*^9, 3.623843516612858*^9}, {3.623845972595862*^9, 
  3.6238460117278748`*^9}}],

Cell[CellGroupData[{

Cell["Expressions", "Subsection",
 CellChangeTimes->{{3.6239921471764936`*^9, 3.623992148448138*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{"x", "+", "y"}], "]"}]], "Input",
 CellChangeTimes->{{3.623992161302047*^9, 3.623992164896904*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Plus", "[", 
    RowBox[{"x", ",", "y"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.6239936639116488`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"x", "+", "y"}], "]"}]], "Input",
 CellChangeTimes->{{3.623992153541724*^9, 3.6239921589531717`*^9}}],

Cell[BoxData["Plus"], "Output",
 CellChangeTimes->{3.623993664005567*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y", ",", "z"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.623992172728611*^9, 3.623992185121687*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"List", "[", 
    RowBox[{"x", ",", "y", ",", "z"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.623993664061123*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Head", "[", 
  RowBox[{"{", 
   RowBox[{"x", ",", "y", ",", "z"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.623992188877152*^9, 3.623992192187594*^9}}],

Cell[BoxData["List"], "Output",
 CellChangeTimes->{3.623993664127267*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"head", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6239921938531647`*^9, 3.623992223545904*^9}}],

Cell[BoxData[
 RowBox[{"head", "[", 
  RowBox[{"x", ",", "y", ",", "z"}], "]"}]], "Output",
 CellChangeTimes->{3.6239936641927633`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Plus", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6239921938531647`*^9, 3.623992215973948*^9}}],

Cell[BoxData[
 RowBox[{"x", "+", "y", "+", "z"}]], "Output",
 CellChangeTimes->{3.623993664253071*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", 
  RowBox[{"Apply", "[", 
   RowBox[{"Plus", ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6239921938531647`*^9, 3.6239922357377043`*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"Plus", "[", 
    RowBox[{"x", ",", "y", ",", "z"}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.6239936643089027`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apply", "[", 
  RowBox[{"Sequence", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.623992245856777*^9, 3.623992261080964*^9}}],

Cell[BoxData[
 RowBox[{"Sequence", "[", 
  RowBox[{"x", ",", "y", ",", "z"}], "]"}]], "Output",
 CellChangeTimes->{3.623993664377537*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "f", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", "x___", "]"}], ":=", 
  RowBox[{"g", "[", "x", "]"}]}]}], "Input",
 CellChangeTimes->{{3.62399226463026*^9, 3.62399232318114*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.623992284800668*^9, 3.623992286528078*^9}}],

Cell[BoxData[
 RowBox[{"g", "[", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "]"}]], "Output",
 CellChangeTimes->{3.623993664469181*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", "f", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f", "[", "x___", "]"}], ":=", 
  RowBox[{"List", "[", "x", "]"}]}]}], "Input",
 CellChangeTimes->{{3.62399226463026*^9, 3.6239923287614393`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.62399233041492*^9, 3.623992332590802*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{3.6239936645531816`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Own Values", "Subsection",
 CellChangeTimes->{{3.623846065376837*^9, 3.6238460684619207`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"a", "=", "42"}]], "Input",
 CellChangeTimes->{{3.623846022166864*^9, 3.623846023880373*^9}}],

Cell[BoxData["42"], "Output",
 CellChangeTimes->{3.623993664629953*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OwnValues", "[", "a", "]"}]], "Input",
 CellChangeTimes->{{3.623846026371838*^9, 3.623846028338825*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", "a", "]"}], "\[RuleDelayed]", "42"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.623993664755468*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Down Values", "Subsection",
 CellChangeTimes->{{3.623846074000051*^9, 3.623846088581354*^9}}],

Cell[TextData[{
 "A ",
 StyleBox["DownValue",
  FontSlant->"Italic"],
 " is defined when the variable itself does not have a meaning, but can get \
one when combined with the proper arguments. This is the case for the most \
function definitions."
}], "Text",
 CellChangeTimes->{{3.623846168724885*^9, 3.623846206371131*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", 
  RowBox[{"x", "^", "2"}]}]], "Input",
 CellChangeTimes->{{3.623846097191597*^9, 3.623846101654459*^9}}],

Cell[TextData[{
 "This defines a pattern for ",
 StyleBox["f",
  FontSlant->"Italic"],
 " specifying that each time ",
 StyleBox["f[...]",
  FontSlant->"Italic"],
 " is encountered, it is to be replaced by ",
 StyleBox["...^2",
  FontSlant->"Italic"],
 ". This pattern is meaningless if there is a lonely ",
 StyleBox["f,",
  FontSlant->"Italic"]
}], "Text",
 CellChangeTimes->{{3.623846168724885*^9, 3.6238462631451473`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["f"], "Input",
 CellChangeTimes->{3.623846246851964*^9}],

Cell[BoxData["f"], "Output",
 CellChangeTimes->{3.623993664922477*^9}]
}, Open  ]],

Cell["\<\
However, when encountered with an argument downwards (i.e. down the internal \
structure of the command you entered), the pattern applies,\
\>", "Text",
 CellChangeTimes->{3.623846257108803*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "[", "y", "]"}]], "Input",
 CellChangeTimes->{{3.6238462803911*^9, 3.623846281507004*^9}}],

Cell[BoxData[
 SuperscriptBox["y", "2"]], "Output",
 CellChangeTimes->{3.6239936650693274`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DownValues", "[", "f", "]"}]], "Input",
 CellChangeTimes->{{3.62384608440178*^9, 3.62384610476077*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"f", "[", "x_", "]"}], "]"}], "\[RuleDelayed]", 
    SuperscriptBox["x", "2"]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{"f", "[", "x___", "]"}], "]"}], "\[RuleDelayed]", 
    RowBox[{"{", "x", "}"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.623993665187221*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Up Values", "Subsection",
 CellChangeTimes->{{3.623846462220026*^9, 3.623846463928928*^9}, {
  3.62385393584126*^9, 3.623853938873225*^9}}],

Cell[TextData[{
 "Sometimes, it\[CloseCurlyQuote]s convenient not to associate the rule to \
the outermost symbol. For example, you may want to have a symbol whose value \
is ",
 StyleBox["2",
  FontSlant->"Italic"],
 " when it has a subscript of ",
 StyleBox["1",
  FontSlant->"Italic"],
 ", for example to define a special case in a sequence. This would be entered \
as follows:"
}], "Text",
 CellChangeTimes->{{3.623846465992867*^9, 3.623846490826021*^9}}],

Cell[BoxData[
 RowBox[{"c", "/:", 
  RowBox[{"Subscript", "[", 
   RowBox[{"c", ",", "1"}], "]"}], ":=", "2"}]], "Input",
 CellChangeTimes->{{3.623846465992867*^9, 3.623846501894375*^9}}],

Cell[TextData[{
 "If the symbol ",
 StyleBox["c",
  FontSlant->"Italic"],
 " is encountered, neither of the discussed patterns apply. ",
 StyleBox["c",
  FontSlant->"Italic"],
 " on its own has no own hence no OwnValue, and looking down the command tree \
of c when seeing ",
 StyleBox["Subscript[c,1]",
  FontSlant->"Italic"],
 " yields nothing, since c is already on an outermost branch. An ",
 StyleBox["UpValue",
  FontSlant->"Italic"],
 " solves this problem: a symbol having an ",
 StyleBox["UpValue",
  FontSlant->"Italic"],
 " defines a pattern where not only the children, but also the parents are to \
be investigated, i.e. Mathematica has to look up the command tree to see \
whether the pattern is to be applied. "
}], "Text",
 CellChangeTimes->{{3.623846465992867*^9, 3.623846491577726*^9}, {
  3.623846584406896*^9, 3.6238465867490664`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"UpValues", "[", "c", "]"}]], "Input",
 CellChangeTimes->{{3.6238465877797813`*^9, 3.623846590296563*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    SubscriptBox["c", "1"], "]"}], "\[RuleDelayed]", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.623993665246684*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sub Values", "Subsection",
 CellChangeTimes->{{3.623865868657464*^9, 3.623865872629456*^9}}],

Cell[TextData[{
 StyleBox["SubValues",
  FontSlant->"Italic"],
 " is used for definitions of the type"
}], "Text",
 CellChangeTimes->{{3.6238658947263536`*^9, 3.623865902196525*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"d", "[", "e", "]"}], "[", "f", "]"}], "=", "x"}], ";"}]], "Input",\

 CellChangeTimes->{{3.623865913147049*^9, 3.623865920189186*^9}}],

Cell[TextData[{
 "This defines neither an ",
 StyleBox["OwnValue",
  FontSlant->"Italic"],
 " nor a ",
 StyleBox["DownValue",
  FontSlant->"Italic"],
 " for ",
 StyleBox["d",
  FontSlant->"Italic"],
 ", since it does not really define the value for the atomic object ",
 StyleBox["d",
  FontSlant->"Italic"],
 " itself, but for ",
 StyleBox["d[e]",
  FontSlant->"Italic"],
 ", which is a composite. Read the definition above as ",
 StyleBox["(d[e])[f]=x",
  FontSlant->"Italic"],
 "."
}], "Text",
 CellChangeTimes->{3.6238659483525753`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SubValues", "[", "d", "]"}]], "Input",
 CellChangeTimes->{{3.623865980165073*^9, 3.623865983877479*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    RowBox[{
     RowBox[{"d", "[", "e", "]"}], "[", "f", "]"}], "]"}], "\[RuleDelayed]", 
   "x"}], "}"}]], "Output",
 CellChangeTimes->{3.623993665350499*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["Examples", "Section",
 CellChangeTimes->{{3.6238433861765738`*^9, 3.623843411247705*^9}, {
  3.623843485997211*^9, 3.623843516612858*^9}, {3.623845972595862*^9, 
  3.623845973825005*^9}}],

Cell[CellGroupData[{

Cell["Counting", "Subsection",
 CellChangeTimes->{{3.623959923624585*^9, 3.6239599247993107`*^9}}],

Cell["\<\
Data in this example are represented as time series of 0\[CloseCurlyQuote]s \
and 1\[CloseCurlyQuote]s.\
\>", "Text",
 CellChangeTimes->{{3.6239593405973873`*^9, 3.6239593655411243`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SeedRandom", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"data", "=", 
  RowBox[{"RandomInteger", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"0", ",", "1"}], "}"}], ",", 
    RowBox[{"{", "20", "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.6238471691597443`*^9, 3.623847178187017*^9}, {
  3.6239935138926277`*^9, 3.623993517154318*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1", ",", "0", ",", "1", ",", "0", ",", "0", ",", "1", ",", "1", ",", "1", 
   ",", "0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0", ",", "0", ",", 
   "0", ",", "0", ",", "0", ",", "1", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{3.623993665451735*^9}]
}, Open  ]],

Cell["Task is to get a sum of 0\[CloseCurlyQuote]s and 1\[CloseCurlyQuote]s \
for each time step.", "Text",
 CellChangeTimes->{{3.62395931824741*^9, 3.62395933745382*^9}, {
  3.62395936861299*^9, 3.623959385268209*^9}}],

Cell[CellGroupData[{

Cell["Idea", "Subsubsection",
 CellChangeTimes->{{3.623993553757338*^9, 3.623993592364492*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"C", " ", "style"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"n", "=", 
     RowBox[{"Length", "[", "data", "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cnt0", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"cnt1", "=", "0"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"output", "=", 
     RowBox[{"Table", "[", 
      RowBox[{"0", ",", 
       RowBox[{"{", "n", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "<=", "n"}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
          "data", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], 
          "\[Equal]", "0"}], ",", 
         RowBox[{"cnt0", "++"}], ",", 
         RowBox[{"cnt1", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
        "output", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}], "=", 
        RowBox[{"{", 
         RowBox[{"cnt0", ",", "cnt1"}], "}"}]}], ";"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
   "output"}]}]], "Input",
 CellChangeTimes->{{3.623993338290106*^9, 3.6239934988207703`*^9}, {
  3.623993534724526*^9, 3.623993569263764*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "7"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.623993665572214*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Example Solutions", "Subsubsection",
 CellChangeTimes->{{3.6239593906440687`*^9, 3.623959392027978*^9}, {
  3.623959780613185*^9, 3.623959782065323*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Tally", "[", 
      RowBox[{
       RowBox[{"Take", "[", 
        RowBox[{"data", ",", "#"}], "]"}], "~", "Join", "~", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "]"}], "\[LeftDoubleBracket]", 
     RowBox[{"All", ",", "2"}], "\[RightDoubleBracket]"}], "-", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], "&"}], "/@", 
  RowBox[{"Range", "[", 
   RowBox[{"Length", "[", "data", "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.623959447247292*^9, 3.623959496762589*^9}, {
  3.623959530071944*^9, 3.623959530730483*^9}, {3.6239595789297867`*^9, 
  3.623959601415283*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "8"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "9"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "11"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "12"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "13"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.623993665717288*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FoldList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"#1", "+", 
     RowBox[{"(", 
      RowBox[{"#2", "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"0", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}]}], ",", 
         RowBox[{"1", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}]}], "}"}]}], ")"}]}], "&"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", "data"}], "]"}]], "Input",
 CellChangeTimes->{{3.6239596616081533`*^9, 3.623959716305066*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "7"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.6239936658197117`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Accumulate", "[", 
  RowBox[{"data", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}], ",", 
     RowBox[{"1", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.623959631091695*^9, 3.623959647385681*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "7"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"13", ",", "7"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.623993665888838*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Recursive Fibonacci Number", "Subsection",
 CellChangeTimes->{{3.6239599317093477`*^9, 3.623959958748838*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fib", "[", "0", "]"}], ":=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fib", "[", "1", "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fib", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"fib", "[", 
     RowBox[{"n", "-", "1"}], "]"}], "+", 
    RowBox[{"fib", "[", 
     RowBox[{"n", "-", "2"}], "]"}]}], "/;", 
   RowBox[{"n", ">", "1"}]}]}]}], "Input",
 CellChangeTimes->{{3.623959962552609*^9, 3.623960022412052*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fib", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.623960029703268*^9, 3.6239600562352467`*^9}}],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{3.623993665961088*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{"fib", "[", "27", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.623960039973894*^9, 3.6239600531005077`*^9}, {
  3.623960092403685*^9, 3.6239601057459927`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.60647699999999993281107890652492642403`6.226474425398977", ",", 
   "196418"}], "}"}]], "Output",
 CellChangeTimes->{3.623993667583068*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{"fib", "[", "28", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.623960039973894*^9, 3.6239601099535723`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2.56164600000000008961364983406383544207`6.429119026639513", ",", 
   "317811"}], "}"}]], "Output",
 CellChangeTimes->{3.6239936702373457`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"fib", "[", "#", "]"}], "]"}], "&"}], "/@", 
     RowBox[{"Range", "[", 
      RowBox[{"1", ",", "20"}], "]"}]}], ")"}], "\[LeftDoubleBracket]", 
   RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]], "Input",
 CellChangeTimes->{{3.623960116290156*^9, 3.623960189712164*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.019444444444444445`],
      AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQDQEf7EOeCBQWa520gwo4ZMqG+gqUvofyORw+Zjzu
2PrjCZQv4GC/+syUa/c/QfkiDop2Gx7vd2Cwh/AlHIoCdZW6TnJD+TIOZuVf
9sd0i0H5Cg4p9t1LPfYpQflKDr6392+6tMQEyldxKHD5viZ7iw2Ur+Zw1EY7
86i5C5Sv4TD5WAbQhQFQvpbDoumBOtu3REH5Og5vv77r/74qFcrXc3hYufLG
jOuFUL6Bg+aLb5OOZdRC+YYOBVset933bYfyjRz+uaQennVqkj2T3YI7Dx4Z
OZy5olLhLDXXHgDmQ1j9
      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{},
  PlotRange->{{0., 20.}, {0, 0.0284205}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.6239936705805597`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"ClearAll", "[", "fib", "]"}]], "Input",
 CellChangeTimes->{{3.6239601991824923`*^9, 3.623960202496749*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fib", "[", "0", "]"}], ":=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"fib", "[", "1", "]"}], ":=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fib", "[", "n_", "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"fib", "[", "n", "]"}], "=", 
     RowBox[{
      RowBox[{"fib", "[", 
       RowBox[{"n", "-", "1"}], "]"}], "+", 
      RowBox[{"fib", "[", 
       RowBox[{"n", "-", "2"}], "]"}]}]}], ")"}], "/;", 
   RowBox[{"n", ">", "1"}]}]}]}], "Input",
 CellChangeTimes->{{3.623960204585381*^9, 3.623960245152143*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fib", "[", "5", "]"}]], "Input",
 CellChangeTimes->{{3.623960029703268*^9, 3.6239600562352467`*^9}}],

Cell[BoxData["5"], "Output",
 CellChangeTimes->{3.623993670683269*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{"fib", "[", "27", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.623960039973894*^9, 3.6239600531005077`*^9}, {
  3.623960092403685*^9, 3.6239601057459927`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00027399999999999999225966385019148674`2.458350476100012", ",", 
   "196418"}], "}"}]], "Output",
 CellChangeTimes->{3.623993670753621*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AbsoluteTiming", "[", 
  RowBox[{"fib", "[", "28", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.623960039973894*^9, 3.6239601099535723`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.00002599999999999999839993443384589256`1.4355732612504422", ",", 
   "317811"}], "}"}]], "Output",
 CellChangeTimes->{3.623993670826907*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"AbsoluteTiming", "[", 
       RowBox[{"fib", "[", "#", "]"}], "]"}], "&"}], "/@", 
     RowBox[{"Range", "[", 
      RowBox[{"1", ",", "20"}], "]"}]}], ")"}], "\[LeftDoubleBracket]", 
   RowBox[{"All", ",", "1"}], "\[RightDoubleBracket]"}], "]"}]], "Input",
 CellChangeTimes->{{3.623960116290156*^9, 3.623960189712164*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.019444444444444445`],
      AbsoluteThickness[1.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQEf7Hvfbl3w/dgBO6iAAwMK4EDjC6DxRRwg+jdA
9Uug8WXQ1CugySuhyaugyauh8TXQ+Fpo+nXQ5PXQ5A3Q5A3R+EZo6o3R5E3g
8gCMD0aR
      "]]}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{},
  PlotRange->{{0., 20.}, {0, 2.*^-6}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.623993670897596*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Composition", "Subsection",
 CellChangeTimes->{{3.623990767442746*^9, 3.623990791008565*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"model", "[", "cfg_List", "]"}], "[", "x_", "]"}], ":=", 
  RowBox[{"Plus", "@@", 
   RowBox[{"MapIndexed", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"#1", 
       RowBox[{"x", "^", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"First", "@", "#2"}], "-", "1"}], ")"}]}]}], "&"}], ",", 
     "cfg"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.623990797631792*^9, 3.623990800156248*^9}, {
  3.623992018809547*^9, 3.623992125997065*^9}, {3.623992397492713*^9, 
  3.623992399474742*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"model", "[", 
   RowBox[{"{", 
    RowBox[{"10", ",", "20", ",", "30", ",", "40"}], "}"}], "]"}], "[", "x", 
  "]"}]], "Input",
 CellChangeTimes->{{3.623992087969244*^9, 3.623992112811482*^9}}],

Cell[BoxData[
 RowBox[{"10", "+", 
  RowBox[{"20", " ", "x"}], "+", 
  RowBox[{"30", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"40", " ", 
   SuperscriptBox["x", "3"]}]}]], "Output",
 CellChangeTimes->{3.62399367097084*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"model", "[", 
   RowBox[{"{", 
    RowBox[{"10", ",", "20", ",", "30", ",", "40"}], "}"}], "]"}], "[", "4", 
  "]"}]], "Input",
 CellChangeTimes->{{3.623992087969244*^9, 3.6239921212428827`*^9}, {
  3.623992406280611*^9, 3.623992417323904*^9}}],

Cell[BoxData["3130"], "Output",
 CellChangeTimes->{3.623993671036839*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"m", "=", 
  RowBox[{"model", "[", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "0.5"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.623992387782435*^9, 3.623992389948351*^9}, {
  3.623992422804192*^9, 3.6239924836644506`*^9}}],

Cell[BoxData[
 RowBox[{"model", "[", 
  RowBox[{"{", 
   RowBox[{"2", ",", "3", ",", "0.5`"}], "}"}], "]"}]], "Output",
 CellChangeTimes->{3.6239936711030693`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"m", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "5"}], ",", "5"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.623992431857792*^9, 3.6239924755940237`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
    1.], LineBox[CompressedData["
1:eJwt2Hk8VN//B/CZuWbmzmSZDElJRFRaZGsZmlPK8qGSRLaSpNKm5SOlBUnI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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic, "ScalingFunctions" -> None},
  PlotRange->{{-5, 5}, {-2.499999856786909, 29.49999836734696}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.623993671176937*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Example: LinearModelFit", "Subsubsection",
 CellChangeTimes->{{3.623992579189527*^9, 3.623992586301283*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "4"}], "}"}]}], "}"}]}], ";"}]], "Input",
 CellID->332479036],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"data", ",", 
   RowBox[{"PlotTheme", "\[Rule]", "\"\<Detailed\>\""}]}], "]"}]], "Input",
 CellChangeTimes->{{3.62399276850404*^9, 3.6239928212155323`*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {{}, 
    {RGBColor[0.368417, 0.506779, 0.709798], PointSize[0.019444444444444445`],
      AbsoluteThickness[1.6], 
     PointBox[{{0., 1.}, {1., 0.}, {3., 2.}, {5., 4.}}]}, {}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{None, None}, {None, None}},
  FrameStyle->Automatic,
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{Automatic, Automatic},
  GridLinesStyle->Directive[
    GrayLevel[0.4, 0.5], 
    AbsoluteThickness[1], 
    AbsoluteDashing[{1, 2}]],
  Method->{},
  PlotRange->{{0, 5.}, {0, 4.}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.623993671271591*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lm", "=", 
  RowBox[{"LinearModelFit", "[", 
   RowBox[{"data", ",", "x", ",", "x"}], "]"}]}]], "Input",
 CellID->516331820],

Cell[BoxData[
 TagBox[
  RowBox[{"FittedModel", "[", 
   TagBox[
    PanelBox[
     TagBox[
      RowBox[{"0.18644067796610198`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.6949152542372881`", " ", "x"}]}],
      Short[#, 2]& ],
     FrameMargins->5],
    Editable -> False], "]"}],
  InterpretTemplate[
  FittedModel[{
    "Linear", {0.18644067796610198`, 
     0.6949152542372881}, {{$CellContext`x}, {1, $CellContext`x}}, {0, 0}}, {{
    1., 1., 1., 1.}}, {{0, 1}, {1, 0}, {3, 2}, {5, 4}}, {{1., 0.}, {1., 1.}, {
    1., 3.}, {1., 5.}}, 
    Function[Null, 
     Internal`LocalizedBlock[{$CellContext`x}, #], {HoldAll}]]& ],
  Editable->False,
  SelectWithContents->True,
  Selectable->True]], "Output",
 CellChangeTimes->{3.62399367157585*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "data", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"lm", "[", "x", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "5"}], "}"}]}], "]"}], ",", 
   RowBox[{"Frame", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellID->250592189],

Cell[BoxData[
 GraphicsBox[{{{}, {{}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.019444444444444445`], AbsoluteThickness[1.6], 
      PointBox[{{0., 1.}, {1., 0.}, {3., 2.}, {5., 
       4.}}]}, {}}, {}}, {{}, {}, 
    {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], Opacity[
     1.], LineBox[CompressedData["
1:eJwVz3080wkcwPHNbIz9FL/LSR6muCQ6ElIvvl89oVBUt9PDeYhaXdmFO3en
XEuJwqVd7aVH5/TotSk9oU57kZeZcUXucvKKNGamxmzmaa774/N6//1xSeTF
JJtQKJTIT/3vlaxEhk9SZvBFx9ydG7sb4eoO9SoOOxa8AsJL/ChS6Iw8ncpm
7wfJFgsFe5EUMkJjrejsn0CRnZ8yzpXChue4a9w5D3xUZ/llY1IQHV+RrXEu
Bumj4ptGSxn0Johth51vg35zubZylRwyo7+NH3KuBveQgQYi4gUwJy41HVwm
A/82YX+aWQccrvslX53aDnTPEwxBaicsKxO8fCDuBGWHg5Hf2A2KKK7D25U9
EMxzgYCgXhDa5zj+Ht8Hg5w2Y15KHwSmVlXQ5P0w/LHpeFerAur/ubSFt1gF
kxXC0c9cleCTbwy2Cx+G/dto7zyiVRDav+qtN0cD3rcengeRGga8Hq0fU49A
bA+9ybv3A2RO5/k+/VkL69m2Y6YnNWBmrdy/zUMHFrfkCs3dEaC30EMt/9QD
ZWHM583SUZhqFR08d9gApdrJO64GLSg44vlOTpOwsbNwxaiLDkJyUw5JRVPA
vjcyIwrQw3ljFXNt3AyU9WQsGUwah50O9RFvtEbYYdLym02WAViSpeqF2ylY
k7k+8Yl4ApL9SnWxnlRkM2+7ve6chIysH2PYOipW5Xa592mm4KRK0N7aaoKT
cT6Fh5xnIMJjzi3WRRqmLPnKtz/QCAUif0lEgikqGXtb26JmQbb1j+n0QDoy
rsqTrwVRUNLCy/ekMfDevcgT8iYKVh7go7ybgcsP92ytTqCi0yZYmfLADB/V
cJ169FRcO7sr+9oRc4w5+trcyDfBpL+fjVZtZ+LzodiyLjsaBvOPP0xgW2BU
e13c3es0PMcbecIasMCudS62z740xXfHrvdfq7XE4MSiowUNpjiUXJ1Ud4qF
1Qal6dZoOmoO2Zi1JBBouTom6LWSjuLw5um9Xlb4vb70/LYfGNjP9fan6ayw
d/Wg0oJqhvbl/wpOtcxBV6+Q4WNCM8yOTy1t2TQXs4THrD8sMsfx6fkFm6rn
olj0st/+qTm6PxEWy1ytsTfS7jE/mol+exo2W+dZ49J9G26+fcNEyeV5dnKd
NUZ45oTNpFmgu2Te6aidNphzQMS0oVpiJF3t2FZrg3XLZQ3xZyxR0/W+vsmD
xFc3DMt5LizkXS4g834l0SiwkqSLWCinun7cWETi/avqCUUFCz321chYAhIP
3Jb5cipZ+N5ngH/2AokdtTk3Ax+z8OtG1AivkHhn0FholLBwzahWfqOcRA58
3J37ioW2YTtynjeSWKn6a+rSFAvTRJqEnCYS9+lEfoSRhS9sTgWFNZPoSMnn
ZVEIPNN9f6y5lcS8eWF98XQCKWnEnvYOEuNQInObQ6DqigTe9ZFIXLhbXLGQ
wFAaZ0GZgsS6ksJ2thuBZdxhffIAiRnlB4lziwmM87UXD6pIfC9x56d7EvhK
muYwMkJizVAJN9CfQJ9lFoZKLYnf6bNK76wksFBQ0p6uI9GNuvvNgtUEhn/T
ctpgILHIdv4WIxB4o37P3ppJEje4jOfx1hBoumQy5Mg0iTNLO+p71hGYUHjW
Mdj46df//kx0KIG12i8mZmdJ5IYUBdSHE/gfvMY6Iw==
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->True,
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{},
  PlotRange->{{0, 5.}, {0, 4.}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.623993671677865*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FullForm", "[", "lm", "]"}]], "Input",
 CellChangeTimes->{{3.623992614587418*^9, 3.623992618049025*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"FittedModel", "[", 
    RowBox[{
     RowBox[{"List", "[", 
      RowBox[{"\"\<Linear\>\"", ",", 
       RowBox[{"List", "[", 
        RowBox[{"0.18644067796610198`", ",", "0.6949152542372881`"}], "]"}], 
       ",", 
       RowBox[{"List", "[", 
        RowBox[{
         RowBox[{"List", "[", "x", "]"}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"1", ",", "x"}], "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"0", ",", "0"}], "]"}]}], "]"}], ",", 
     RowBox[{"List", "[", 
      RowBox[{"List", "[", 
       RowBox[{"1.`", ",", "1.`", ",", "1.`", ",", "1.`"}], "]"}], "]"}], ",", 
     RowBox[{"List", "[", 
      RowBox[{
       RowBox[{"List", "[", 
        RowBox[{"0", ",", "1"}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"1", ",", "0"}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"3", ",", "2"}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"5", ",", "4"}], "]"}]}], "]"}], ",", 
     RowBox[{"List", "[", 
      RowBox[{
       RowBox[{"List", "[", 
        RowBox[{"1.`", ",", "0.`"}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"1.`", ",", "1.`"}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"1.`", ",", "3.`"}], "]"}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"1.`", ",", "5.`"}], "]"}]}], "]"}], ",", 
     RowBox[{"Function", "[", 
      RowBox[{"Null", ",", 
       RowBox[{"Internal`LocalizedBlock", "[", 
        RowBox[{
         RowBox[{"List", "[", "x", "]"}], ",", 
         RowBox[{"Slot", "[", "1", "]"}]}], "]"}], ",", 
       RowBox[{"List", "[", "HoldAll", "]"}]}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output",
 CellChangeTimes->{3.623993671727385*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lm", "[", "\"\<Properties\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.623992656305355*^9, 3.623992662853438*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"AdjustedRSquared\"\>", ",", "\<\"AIC\"\>", ",", "\<\"AICc\"\>",
    ",", "\<\"ANOVATable\"\>", ",", "\<\"ANOVATableDegreesOfFreedom\"\>", 
   ",", "\<\"ANOVATableEntries\"\>", ",", "\<\"ANOVATableFStatistics\"\>", 
   ",", "\<\"ANOVATableMeanSquares\"\>", ",", "\<\"ANOVATablePValues\"\>", 
   ",", "\<\"ANOVATableSumsOfSquares\"\>", ",", "\<\"BasisFunctions\"\>", 
   ",", "\<\"BetaDifferences\"\>", ",", "\<\"BestFit\"\>", 
   ",", "\<\"BestFitParameters\"\>", ",", "\<\"BIC\"\>", 
   ",", "\<\"CatcherMatrix\"\>", ",", "\<\"CoefficientOfVariation\"\>", 
   ",", "\<\"CookDistances\"\>", ",", "\<\"CorrelationMatrix\"\>", 
   ",", "\<\"CovarianceMatrix\"\>", ",", "\<\"CovarianceRatios\"\>", 
   ",", "\<\"Data\"\>", ",", "\<\"DesignMatrix\"\>", 
   ",", "\<\"DurbinWatsonD\"\>", ",", "\<\"EigenstructureTable\"\>", 
   ",", "\<\"EigenstructureTableEigenvalues\"\>", 
   ",", "\<\"EigenstructureTableEntries\"\>", 
   ",", "\<\"EigenstructureTableIndexes\"\>", 
   ",", "\<\"EigenstructureTablePartitions\"\>", 
   ",", "\<\"EstimatedVariance\"\>", ",", "\<\"FitDifferences\"\>", 
   ",", "\<\"FitResiduals\"\>", ",", "\<\"Function\"\>", 
   ",", "\<\"FVarianceRatios\"\>", ",", "\<\"HatDiagonal\"\>", 
   ",", "\<\"MeanPredictionBands\"\>", 
   ",", "\<\"MeanPredictionConfidenceIntervals\"\>", 
   ",", "\<\"MeanPredictionConfidenceIntervalTable\"\>", 
   ",", "\<\"MeanPredictionConfidenceIntervalTableEntries\"\>", 
   ",", "\<\"MeanPredictionErrors\"\>", 
   ",", "\<\"ParameterConfidenceIntervals\"\>", 
   ",", "\<\"ParameterConfidenceIntervalTable\"\>", 
   ",", "\<\"ParameterConfidenceIntervalTableEntries\"\>", 
   ",", "\<\"ParameterConfidenceRegion\"\>", ",", "\<\"ParameterErrors\"\>", 
   ",", "\<\"ParameterPValues\"\>", ",", "\<\"ParameterTable\"\>", 
   ",", "\<\"ParameterTableEntries\"\>", ",", "\<\"ParameterTStatistics\"\>", 
   ",", "\<\"PartialSumOfSquares\"\>", ",", "\<\"PredictedResponse\"\>", 
   ",", "\<\"Properties\"\>", ",", "\<\"Response\"\>", 
   ",", "\<\"RSquared\"\>", ",", "\<\"SequentialSumOfSquares\"\>", 
   ",", "\<\"SingleDeletionVariances\"\>", 
   ",", "\<\"SinglePredictionBands\"\>", 
   ",", "\<\"SinglePredictionConfidenceIntervals\"\>", 
   ",", "\<\"SinglePredictionConfidenceIntervalTable\"\>", 
   ",", "\<\"SinglePredictionConfidenceIntervalTableEntries\"\>", 
   ",", "\<\"SinglePredictionErrors\"\>", 
   ",", "\<\"StandardizedResiduals\"\>", ",", "\<\"StudentizedResiduals\"\>", 
   ",", "\<\"VarianceInflationFactors\"\>"}], "}"}]], "Output",
 CellChangeTimes->{3.623993671782385*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lm", "[", "\"\<FitResiduals\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.623992701050425*^9, 3.6239927081207438`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.813559322033898`", ",", 
   RowBox[{"-", "0.88135593220339`"}], ",", 
   RowBox[{"-", "0.27118644067796627`"}], ",", "0.3389830508474576`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.623993671849415*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"lm", "[", "\"\<FitResiduals\>\"", "]"}], ",", " ", 
   RowBox[{"Filling", "\[Rule]", "Axis"}]}], "]"}]], "Input",
 CellID->131449341],

Cell[BoxData[
 GraphicsBox[{{}, 
   GraphicsComplexBox[{{1., 0.813559322033898}, {2., -0.88135593220339}, {
    3., -0.27118644067796627`}, {4., 0.3389830508474576}, {1., 0.}, {2., 
    0.}, {3., 0.}, {4., 0.}, {1., 0.813559322033898}, {
    2., -0.88135593220339}, {3., -0.27118644067796627`}, {4., 
    0.3389830508474576}}, {{{}, {}, {}, 
      {RGBColor[0.368417, 0.506779, 0.709798], Opacity[0.3], LineBox[{6, 2}], 
       LineBox[{7, 3}]}, 
      {RGBColor[0.368417, 0.506779, 0.709798], Opacity[0.3], LineBox[{5, 1}], 
       LineBox[{8, 4}]}}, {{}, 
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.019444444444444445`], AbsoluteThickness[1.6], 
       PointBox[{9, 10, 11, 12}]}, {}}}], {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0, 0},
  DisplayFunction->Identity,
  Frame->{{False, False}, {False, False}},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{},
  PlotRange->{{0., 4.}, {-0.88135593220339, 0.813559322033898}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.05], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{3.623993671930132*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["", "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],

Cell[CellGroupData[{

Cell["References", "Section",
 CellChangeTimes->{{3.6238433861765738`*^9, 3.623843411247705*^9}, {
  3.623843485997211*^9, 3.623843516612858*^9}, {3.623845972595862*^9, 
  3.623845973825005*^9}, {3.62384660072726*^9, 3.623846602140336*^9}}],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["http://mathematica.stackexchange.com/questions/96/\
what-is-the-distinction-between-downvalues-upvalues-subvalues-and-ownvalues",
 BaseStyle->"Hyperlink",
 ButtonData->{
   URL["http://mathematica.stackexchange.com/questions/96/what-is-the-\
distinction-between-downvalues-upvalues-subvalues-and-ownvalues"], None},
 ButtonNote->
  "http://mathematica.stackexchange.com/questions/96/what-is-the-distinction-\
between-downvalues-upvalues-subvalues-and-ownvalues"]], "Item",
 CellChangeTimes->{{3.6238466139391212`*^9, 3.623846620836081*^9}, {
  3.623847050356381*^9, 3.623847050361393*^9}}],

Cell[TextData[{
 "Hudak, Paul: ",
 StyleBox["Conception, evolution, and application of functional programming \
languages",
  FontSlant->"Italic"],
 ". September 1989, ACM Computing Surveys 21 (3): 359\[Dash]411. \
doi:10.1145/72551.72554; ",
 ButtonBox["http://www.dbnet.ece.ntua.gr/~adamo/languages/books/p359-hudak.\
pdf",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.dbnet.ece.ntua.gr/~adamo/languages/books/p359-hudak.pdf"],
     None},
  ButtonNote->
   "http://www.dbnet.ece.ntua.gr/~adamo/languages/books/p359-hudak.pdf"]
}], "Item",
 CellChangeTimes->{{3.6238466139391212`*^9, 3.623846614798864*^9}, {
  3.6238469488606853`*^9, 3.6238469503449183`*^9}, {3.6238469907108927`*^9, 
  3.6238470390783777`*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1242, 755},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September 9, \
2014)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    StyleData["Subsection"], ShowGroupOpener -> True], 
   Cell[
    StyleData["Subsubsection"], ShowGroupOpener -> True]}, Visible -> False, 
  FrontEndVersion -> 
  "10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September 9, 2014)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "SlideShowHeader"->{
  Cell[580, 22, 64, 1, 74, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[2340, 64, 64, 1, 74, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[13634, 476, 64, 1, 74, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[29341, 1083, 64, 1, 74, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[40714, 1516, 64, 1, 74, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"],
  Cell[79165, 2646, 64, 1, 74, "SlideShowNavigationBar",
   CellTags->"SlideShowHeader"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"SlideShowHeader", 81636, 2715}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 64, 1, 74, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[647, 25, 246, 6, 92, "Title"],
Cell[896, 33, 218, 3, 51, "Subtitle"],
Cell[1117, 38, 126, 1, 29, "Subsubtitle"],
Cell[1246, 41, 502, 9, 69, "Subsubtitle"],
Cell[1751, 52, 552, 7, 29, "Subsubtitle"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2340, 64, 64, 1, 74, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[2429, 69, 148, 2, 64, "Section"],
Cell[CellGroupData[{
Cell[2602, 75, 112, 1, 44, "Subsection"],
Cell[2717, 78, 1282, 32, 106, "Text"],
Cell[CellGroupData[{
Cell[4024, 114, 154, 3, 28, "Item"],
Cell[4181, 119, 105, 1, 28, "Item"],
Cell[4289, 122, 142, 1, 28, "Item"],
Cell[4434, 125, 228, 5, 28, "Item"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4711, 136, 123, 1, 44, "Subsection"],
Cell[CellGroupData[{
Cell[4859, 141, 113, 1, 35, "Subsubsection"],
Cell[4975, 144, 153, 4, 28, "Item"],
Cell[5131, 150, 200, 5, 28, "Input"],
Cell[CellGroupData[{
Cell[5356, 159, 146, 3, 28, "Input"],
Cell[5505, 164, 83, 2, 33, "Output"]
}, Open  ]],
Cell[5603, 169, 312, 9, 28, "Input"],
Cell[CellGroupData[{
Cell[5940, 182, 149, 3, 28, "Input"],
Cell[6092, 187, 192, 6, 41, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6321, 198, 176, 4, 28, "Input"],
Cell[6500, 204, 103, 3, 33, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6652, 213, 105, 1, 35, "Subsubsection"],
Cell[6760, 216, 131, 1, 30, "Text"],
Cell[CellGroupData[{
Cell[6916, 221, 196, 4, 28, "Item"],
Cell[7115, 227, 276, 5, 28, "Item"],
Cell[7394, 234, 324, 6, 28, "Item"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7755, 245, 458, 13, 33, "Input"],
Cell[8216, 260, 473, 15, 71, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8726, 280, 222, 6, 28, "Input"],
Cell[8951, 288, 203, 6, 34, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9191, 299, 257, 7, 28, "Input"],
Cell[9451, 308, 116, 3, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9604, 316, 191, 5, 28, "Input"],
Cell[9798, 323, 116, 3, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9951, 331, 306, 9, 28, "Input"],
Cell[10260, 342, 162, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10459, 351, 314, 9, 28, "Input"],
Cell[10776, 362, 162, 4, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10987, 372, 100, 1, 35, "Subsubsection"],
Cell[11090, 375, 150, 4, 30, "Text"],
Cell[11243, 381, 484, 14, 63, "Input"],
Cell[CellGroupData[{
Cell[11752, 399, 122, 2, 28, "Input"],
Cell[11877, 403, 70, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11984, 409, 122, 2, 28, "Input"],
Cell[12109, 413, 71, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12217, 419, 121, 2, 28, "Input"],
Cell[12341, 423, 76, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12454, 429, 237, 5, 46, "Input"],
Cell[12694, 436, 156, 4, 28, "Output"]
}, Open  ]],
Cell[12865, 443, 199, 4, 28, "Input"],
Cell[CellGroupData[{
Cell[13089, 451, 159, 4, 28, "Input"],
Cell[13251, 457, 298, 10, 28, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13634, 476, 64, 1, 74, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[13723, 481, 262, 7, 64, "Section"],
Cell[CellGroupData[{
Cell[14010, 492, 159, 2, 44, "Subsection"],
Cell[14172, 496, 426, 10, 46, "Input"],
Cell[CellGroupData[{
Cell[14623, 510, 122, 2, 28, "Input"],
Cell[14748, 514, 123, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14908, 522, 386, 10, 46, "Input"],
Cell[15297, 534, 205, 6, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15539, 545, 125, 2, 28, "Input"],
Cell[15667, 549, 123, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15827, 557, 314, 9, 28, "Input"],
Cell[16144, 568, 123, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16304, 576, 300, 8, 28, "Input"],
Cell[16607, 586, 123, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16767, 594, 340, 9, 28, "Input"],
Cell[17110, 605, 123, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17270, 613, 160, 2, 35, "Subsubsection"],
Cell[17433, 617, 290, 7, 46, "Input"],
Cell[CellGroupData[{
Cell[17748, 628, 145, 3, 28, "Input"],
Cell[17896, 633, 128, 3, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18061, 641, 314, 9, 28, "Input"],
Cell[18378, 652, 128, 3, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[18543, 660, 224, 6, 28, "Input"],
Cell[18770, 668, 126, 3, 32, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18957, 678, 152, 2, 44, "Subsection"],
Cell[19112, 682, 127, 2, 28, "Input"],
Cell[CellGroupData[{
Cell[19264, 688, 122, 2, 28, "Input"],
Cell[19389, 692, 97, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19523, 699, 115, 2, 28, "Input"],
Cell[19641, 703, 97, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19775, 710, 118, 2, 28, "Input"],
Cell[19896, 714, 97, 2, 28, "Output"]
}, Open  ]],
Cell[20008, 719, 196, 5, 28, "Input"],
Cell[CellGroupData[{
Cell[20229, 728, 116, 2, 28, "Input"],
Cell[20348, 732, 120, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20505, 740, 188, 5, 28, "Input"],
Cell[20696, 747, 120, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20853, 755, 237, 6, 28, "Input"],
Cell[21093, 763, 202, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21332, 773, 251, 6, 28, "Input"],
Cell[21586, 781, 148, 4, 48, "Output"]
}, Open  ]],
Cell[21749, 788, 365, 9, 46, "Input"],
Cell[CellGroupData[{
Cell[22139, 801, 124, 2, 28, "Input"],
Cell[22266, 805, 148, 4, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22451, 814, 299, 9, 28, "Input"],
Cell[22753, 825, 148, 4, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22938, 834, 298, 8, 28, "Input"],
Cell[23239, 844, 150, 4, 48, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23426, 853, 116, 2, 28, "Input"],
Cell[23545, 857, 94, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23676, 864, 148, 3, 28, "Input"],
Cell[23827, 869, 92, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23956, 876, 128, 2, 28, "Input"],
Cell[24087, 880, 92, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24216, 887, 242, 6, 28, "Input"],
Cell[24461, 895, 160, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24658, 904, 246, 7, 28, "Input"],
Cell[24907, 913, 140, 4, 32, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25096, 923, 95, 1, 44, "Subsection"],
Cell[25194, 926, 383, 9, 46, "Input"],
Cell[CellGroupData[{
Cell[25602, 939, 124, 2, 28, "Input"],
Cell[25729, 943, 145, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25911, 951, 205, 4, 28, "Input"],
Cell[26119, 957, 205, 6, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26361, 968, 178, 4, 28, "Input"],
Cell[26542, 974, 417, 13, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26996, 992, 148, 3, 28, "Input"],
Cell[27147, 997, 417, 13, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[27601, 1015, 131, 2, 28, "Input"],
Cell[27735, 1019, 87, 2, 28, "Output"]
}, Open  ]],
Cell[27837, 1024, 162, 3, 28, "Input"],
Cell[CellGroupData[{
Cell[28024, 1031, 151, 3, 28, "Input"],
Cell[28178, 1036, 415, 13, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28630, 1054, 220, 6, 28, "Input"],
Cell[28853, 1062, 415, 13, 28, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29341, 1083, 64, 1, 74, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[29430, 1088, 266, 7, 64, "Section"],
Cell[CellGroupData[{
Cell[29721, 1099, 101, 1, 44, "Subsection"],
Cell[CellGroupData[{
Cell[29847, 1104, 150, 3, 28, "Input"],
Cell[30000, 1109, 250, 9, 39, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30287, 1123, 148, 3, 28, "Input"],
Cell[30438, 1128, 73, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30548, 1134, 184, 4, 28, "Input"],
Cell[30735, 1140, 258, 9, 39, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31030, 1154, 180, 4, 28, "Input"],
Cell[31213, 1160, 73, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31323, 1166, 211, 5, 28, "Input"],
Cell[31537, 1173, 135, 3, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31709, 1181, 211, 5, 28, "Input"],
Cell[31923, 1188, 102, 2, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32062, 1195, 251, 6, 28, "Input"],
Cell[32316, 1203, 260, 9, 39, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[32613, 1217, 213, 5, 28, "Input"],
Cell[32829, 1224, 137, 3, 28, "Output"]
}, Open  ]],
Cell[32981, 1230, 255, 6, 46, "Input"],
Cell[CellGroupData[{
Cell[33261, 1240, 163, 3, 28, "Input"],
Cell[33427, 1245, 140, 3, 28, "Output"]
}, Open  ]],
Cell[33582, 1251, 261, 6, 46, "Input"],
Cell[CellGroupData[{
Cell[33868, 1261, 162, 3, 28, "Input"],
Cell[34033, 1266, 137, 3, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34219, 1275, 100, 1, 44, "Subsection"],
Cell[CellGroupData[{
Cell[34344, 1280, 116, 2, 28, "Input"],
Cell[34463, 1284, 71, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[34571, 1290, 128, 2, 28, "Input"],
Cell[34702, 1294, 171, 5, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34922, 1305, 99, 1, 44, "Subsection"],
Cell[35024, 1308, 325, 8, 49, "Text"],
Cell[35352, 1318, 168, 4, 28, "Input"],
Cell[35523, 1324, 426, 14, 30, "Text"],
Cell[CellGroupData[{
Cell[35974, 1342, 69, 1, 28, "Input"],
Cell[36046, 1345, 70, 1, 28, "Output"]
}, Open  ]],
Cell[36131, 1349, 204, 4, 30, "Text"],
Cell[CellGroupData[{
Cell[36360, 1357, 118, 2, 28, "Input"],
Cell[36481, 1361, 95, 2, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[36613, 1368, 127, 2, 28, "Input"],
Cell[36743, 1372, 386, 11, 35, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37178, 1389, 145, 2, 44, "Subsection"],
Cell[37326, 1393, 459, 12, 49, "Text"],
Cell[37788, 1407, 187, 4, 28, "Input"],
Cell[37978, 1413, 855, 22, 68, "Text"],
Cell[CellGroupData[{
Cell[38858, 1439, 129, 2, 28, "Input"],
Cell[38990, 1443, 191, 5, 28, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[39230, 1454, 98, 1, 44, "Subsection"],
Cell[39331, 1457, 182, 5, 30, "Text"],
Cell[39516, 1464, 194, 6, 28, "Input"],
Cell[39713, 1472, 540, 21, 49, "Text"],
Cell[CellGroupData[{
Cell[40278, 1497, 128, 2, 28, "Input"],
Cell[40409, 1501, 232, 7, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[40714, 1516, 64, 1, 74, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[40803, 1521, 193, 3, 64, "Section"],
Cell[CellGroupData[{
Cell[41021, 1528, 98, 1, 44, "Subsection"],
Cell[41122, 1531, 197, 4, 30, "Text"],
Cell[CellGroupData[{
Cell[41344, 1539, 378, 9, 46, "Input"],
Cell[41725, 1550, 306, 6, 28, "Output"]
}, Open  ]],
Cell[42046, 1559, 219, 3, 30, "Text"],
Cell[CellGroupData[{
Cell[42290, 1566, 95, 1, 35, "Subsubsection"],
Cell[CellGroupData[{
Cell[42410, 1571, 1455, 40, 182, "Input"],
Cell[43868, 1613, 1280, 43, 70, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[45197, 1662, 159, 2, 29, "Subsubsection"],
Cell[CellGroupData[{
Cell[45381, 1668, 675, 18, 28, "Input"],
Cell[46059, 1688, 1280, 43, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47376, 1736, 569, 17, 28, "Input"],
Cell[47948, 1755, 1341, 45, 70, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49326, 1805, 379, 11, 28, "Input"],
Cell[49708, 1818, 1280, 43, 70, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[51049, 1868, 116, 1, 44, "Subsection"],
Cell[51168, 1871, 543, 18, 63, "Input"],
Cell[CellGroupData[{
Cell[51736, 1893, 124, 2, 28, "Input"],
Cell[51863, 1897, 70, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51970, 1903, 217, 4, 28, "Input"],
Cell[52190, 1909, 184, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52411, 1919, 166, 3, 28, "Input"],
Cell[52580, 1924, 186, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52803, 1934, 438, 11, 28, "Input"],
Cell[53244, 1947, 1193, 31, 237, "Output"]
}, Open  ]],
Cell[54452, 1981, 131, 2, 28, "Input"],
Cell[54586, 1985, 635, 21, 63, "Input"],
Cell[CellGroupData[{
Cell[55246, 2010, 124, 2, 28, "Input"],
Cell[55373, 2014, 70, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55480, 2020, 217, 4, 28, "Input"],
Cell[55700, 2026, 184, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[55921, 2036, 166, 3, 28, "Input"],
Cell[56090, 2041, 185, 5, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[56312, 2051, 438, 11, 28, "Input"],
Cell[56753, 2064, 993, 28, 225, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57795, 2098, 99, 1, 44, "Subsection"],
Cell[57897, 2101, 548, 16, 28, "Input"],
Cell[CellGroupData[{
Cell[58470, 2121, 228, 6, 28, "Input"],
Cell[58701, 2129, 234, 7, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58972, 2141, 279, 7, 28, "Input"],
Cell[59254, 2150, 73, 1, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59364, 2156, 259, 6, 28, "Input"],
Cell[59626, 2164, 163, 4, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59826, 2173, 257, 7, 28, "Input"],
Cell[60086, 2182, 6424, 116, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66547, 2303, 114, 1, 35, "Subsubsection"],
Cell[66664, 2306, 371, 13, 28, "Input",
 CellID->332479036],
Cell[CellGroupData[{
Cell[67060, 2323, 207, 4, 28, "Input"],
Cell[67270, 2329, 966, 28, 249, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68273, 2362, 148, 4, 28, "Input",
 CellID->516331820],
Cell[68424, 2368, 748, 22, 42, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69209, 2395, 338, 10, 28, "Input",
 CellID->250592189],
Cell[69550, 2407, 2691, 57, 249, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72278, 2469, 128, 2, 28, "Input"],
Cell[72409, 2473, 1829, 51, 74, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[74275, 2529, 138, 2, 28, "Input"],
Cell[74416, 2533, 2588, 43, 199, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77041, 2581, 142, 2, 28, "Input"],
Cell[77186, 2585, 246, 6, 28, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77469, 2596, 197, 5, 28, "Input",
 CellID->131449341],
Cell[77669, 2603, 1411, 34, 229, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[79165, 2646, 64, 1, 74, "SlideShowNavigationBar",
 CellTags->"SlideShowHeader"],
Cell[CellGroupData[{
Cell[79254, 2651, 240, 3, 64, "Section"],
Cell[CellGroupData[{
Cell[79519, 2658, 614, 10, 28, "Item"],
Cell[80136, 2670, 732, 18, 45, "Item"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
